%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% commands

% |\tikzphlpptmplset| allows keys that belong to pgf-phlpptmpl to be easily set.
\newcommand\tikzphlpptmplset[1]{\tikzset{/phlpptmpl/.cd, #1}}%
% |\tikzphlpptmplget| allows keys that belong to pgf-phlpptmpl to be easily retrieved.
\newcommand\tikzphlpptmplget[1]{\pgfkeysvalueof{/phlpptmpl/#1}}%
% |\pgfphlpptmplresetstyle| allows resetting a style within pgf-phlpptmpl quite easily
\newcommand\pgfphlpptmplresetstyle[1]{\tikzset{/phlpptmpl/#1/.style={}}}%

%% END commands
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% load libraries

\usepgflibrary{plotmarks}
\usepgflibrary{fpu}
\usetikzlibrary{3d}
\usetikzlibrary{colorbrewer}
\usetikzlibrary{arrows}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{bending}
\usetikzlibrary{calc}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{external}
\usetikzlibrary{fadings}
\usetikzlibrary{patterns}
\usetikzlibrary{pgfplots.statistics}
\usetikzlibrary{shapes.misc}
\usetikzlibrary{spy}
\usetikzlibrary{through}

\usepgfplotslibrary{statistics}

\pgfplotsset{compat=newest}

%% END load libraries
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% setup

\pgfkeys{%
  % This namespace is a family of namespaces
  /phlpptmpl/.is family,%
  % Fall back to searching inside /pgf/
  /phlpptmpl/.belongs to family=/pgf,%
  % % Forward anything unknown to the '/pgf' namespace
  % /phlpptmpl/.unknown/.forward to=/pgf,%
}%

%% END setup
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% interface

% Set an initially empty style for "remaining keys"
\pgfphlpptmplresetstyle{remaining keys}%

% Handling of unknown options
\tikzphlpptmplset{%
  % Remaining keys not matching in this namespace
  remaining keys/.style={},%
  %
  % collect unknown keys in style 'phlpptmpl/remaining keys':
  .unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \pgfqkeys{phlpptmpl}{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \pgfqkeys{phlpptmpl}{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  }%
}%

% Marker styling
\newlength\tikz@phlpptmpl@markersize
\tikzphlpptmplset{%
  % Default marker size for automatically marked lines
  marker size/.code={%
    \setlength{\tikz@phlpptmpl@markersize}{#1}%
  },%
  % Set marker size
  marker size=1.50pt,%
  %
  % Default number of markers for automatically marked lines
  marker count/.initial=7,%
}

% Colors
\tikzphlpptmplset{%
  % Axis border and background
  axis border color/.initial=PrimaryColor,%
  axis background color/.initial=White,%
  %
  % Legend border color and background
  legend background color/.initial=PrimaryColorVeryLight!50!White,%
  legend border color/.initial=PrimaryColor,%
  %
  % Grid colors
  minor grid color/.initial=PrimaryColor!30,%
  major grid color/.initial=PrimaryColor!50,%
  %
  % Axes labels
  label color/.initial=PrimaryColor,%
  xlabel color/.initial=PrimaryColor,%
  ylabel color/.initial=PrimaryColor,%
  zlabel color/.initial=PrimaryColor,%
  %
  % Axes titles
  title color/.initial=PrimaryColor,%
  %
  % Zoom-in Spy Box
  zoom in spy box color/.initial=AccentOne,%
}

%% END interface
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% node styles

\tikzphlpptmplset{%
  % No inside margin
  no margin/.style={%
    inner sep=0pt,%
  },%
  % A very tight node inside
  very tight margin/.style={%
    inner sep=0.0416625em,%
  },%
  % A tight node inside
  tight margin/.style={%
    inner sep=0.16665em,%
  },%
  % Normal node inside
  normal margin/.style={%
    inner sep=0.3333em,%
  },%
  % Loose node inside
  loose margin/.style={%
    inner sep=0.6666em,%
  },%
  % Very loose node inside
  very loose margin/.style={%
    inner sep=1.3332em,%
  },%
  super loose margin/.style={%
    inner sep=5.3328em,%
  },%
  % No outside distance
  no padding/.style={%
    outer sep=0pt,%
  },%
  % A very tight node outside
  very tight padding/.style={%
    outer sep=0.0416625em,%
  },%
  % A tight node outside
  tight padding/.style={%
    outer sep=0.16665em,%
  },%
  % A normal node outside
  normal padding/.style={%
    outer sep=0.3333em,%
  },%
  % A loose node outside
  loose padding/.style={%
    outer sep=0.6666em,%
  },%
  % A very loose node outside
  very loose padding/.style={%
    outer sep=1.3332em,%
  },%
  super loose padding/.style={%
    outer sep=5.3328em,%
  },%
  % A boxed node
  boxed/.style={%
    draw,%
  },%
  %
  % A highlighted style
  highlighted/.style={%
    color=\tikzphlpptmplget{highlight color},%
  },%
  % Draw a top border
  top border/.style={%
    append after command={%
      \pgfextra{%
        \begin{pgfinterruptpath}%
          \draw[%
              #1,%
            ]%
            (\tikzlastnode.north west)%
            -- (\tikzlastnode.north east)%
            ;%
        \end{pgfinterruptpath}%
      }%
    }%
  },%
  % Draw a right border
  right border/.style={%
    append after command={%
      \pgfextra{%
        \begin{pgfinterruptpath}%
          \draw[%
              #1,%
            ]%
            (\tikzlastnode.north east)%
            -- (\tikzlastnode.south east)%
            ;%
        \end{pgfinterruptpath}%
      }%
    }%
  },%
  % Draw a bottom border
  bottom border/.style={%
    append after command={%
      \pgfextra{%
        \begin{pgfinterruptpath}%
          \draw[%
              #1,%
            ]%
            (\tikzlastnode.south east)%
            -- (\tikzlastnode.south west)%
            ;%
        \end{pgfinterruptpath}%
      }%
    }%
  },%
  % Draw a left border
  left border/.style={%
    append after command={%
      \pgfextra{%
        \begin{pgfinterruptpath}%
          \draw[%
              #1,%
            ]%
            (\tikzlastnode.south west)%
            -- (\tikzlastnode.north west)%
            ;%
        \end{pgfinterruptpath}%
      }%
    }%
  },%
  % left bordered/.initial={},%
  cross/.style={%
    cross out,%
    draw,%
    minimum size=2(#1-\pgflinewidth),%
    inner sep=0pt,%
    outer sep=0pt,%
  },%
  cross/.default={1pt},%
}
%% END node styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% euclidean drawing

\tikzset{%
  % 2D tangent
  tangent/.style={%
    decoration={%
      markings,%
      mark=%
        at position #1%
          with%
          {%
            \coordinate%
              (tangent point-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
              at%
              (0,0);%
            \coordinate%
              (tangent unit vector-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
              at (1,0);%
            \coordinate%
              (normal unit vector-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
              at (0,1);%
          },%
    },%
    postaction=decorate,%
  },%
  use tangent/.style={%
    shift=(tangent point-#1),%
    x=(tangent unit vector-#1),%
    y=(normal unit vector-#1),%
  },%
  use tangent/.default=1,%
  %
  % 3D tangent
  tangent 3/.style={%
    decoration={%
      markings,%
      mark=%
        at position #1%
        with%
        {%
          \coordinate%
            (tangent 3 point-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
            at (0.00,0.00,0.00);%
          \coordinate%
            (tangent 3 unit vector-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
            at (0.00,1.00,0.00);%
          \coordinate%
            (normal 3 unit vector-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
            at (-1.00,0.00,0.00);%
          \coordinate%
            (binormal 3 unit vector-\pgfkeysvalueof{/pgf/decoration/mark info/sequence number})%
            at (0.00,0.00,1.00);%
        },%
    },%
    postaction=decorate,%
  },%
  use tangent 3/.style={%
    shift=(tangent 3 point-#1),%
    x=(tangent 3 unit vector-#1),%
    y=(normal 3 unit vector-#1),%
    z=(binormal 3 unit vector-#1),%
  },%
  use tangent 3/.default=1,%
}

%% END euclidean drawing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% line styles

\tikzphlpptmplset{%
  % Make every line wider than the usual 4pt
  ultra thin/.style={%
    line width=0.02em,%
  },%
  very thin/.style={%
    line width=0.04em,%
  },%
  thin/.style={% DEFAULT
    line width=0.08em,%
  },%
  semithick/.style={%
    line width=0.12em,%
  },%
  thick/.style={%
    line width=0.16em,%
  },%
  very thick/.style={%
    line width=0.32em,%
  },%
  ultra thick/.style={%
    line width=0.64em,%
  },%
}


% Coordinate things
\tikzphlpptmplset{%
  % Coordinate system center
  coordinate system/.style={%
    color=PrimaryColor,%
  },%
  % A general coordinate axis (X, Y, Z)
  coordinate axis/.style={%
    ->,%
    draw=PrimaryColor,%
    color=PrimaryColor,%
  },%
  % X-axis: colored red
  coordinate axis x/.style={%
    /phlpptmpl/coordinate axis,%
    color=Red,%
  },%
  % Y-axis: colored green
  coordinate axis y/.style={%
    /phlpptmpl/coordinate axis,%
    color=Green,%
  },%
  % Z-axis: colored blue
  coordinate axis z/.style={%
    /phlpptmpl/coordinate axis,%
    color=Blue,%
  },%
  %
  % Label of any coordinate axis
  coordinate axis label/.style={%
    pos=1.00,%
    % font=\relsize{-1},%
    /phlpptmpl/tight padding,%
    /phlpptmpl/no margin,%
  },%
}

%% END line styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% global tikz styles

\tikzset{%
  % Default line arrow style
  >=Stealth,%
  %
  % Style to avoid additional post actions to be performed
  nomorepostactions/.code={%
    \let\tikz@postactions=\pgfutil@empty%
  },%
  %
  % Per default, the "evenly marked plot" style will do nothing
  evenly marked plot/.style 2 args={%
    mark=#1,%
    mark options={#2},%
    mark repeat=179,%
  },%
  %
  % Every mark a little bit smaller
  mark size=2.15pt,%
}%

% Some styles will not be set in draft mode
\ifdraft{% In draft mode
  %
}{% In non-draft mode
  \tikzset{%
    %
    % Mark the curent line evenly along the x-axis
    evenly marked plot/.style 2 args={%
      postaction={%
        decoration={%
          markings,%
          mark=between positions 0 and 1%
            step (1/(\tikzphlpptmplget{marker count} - 1)*\pgfdecoratedpathlength%
            with {%
              \tikzset{#2, every mark}\tikz@options%
              \pgfuseplotmark{#1}%
            },%
        },%
        decorate,%
      },%
      /pgfplots/legend image post style={%
        mark=#1,%
        every mark/.append style={%
          #2%
        },%
        every path/.append style={%
          nomorepostactions,%
        },%
      },%
    },%
  }%
}

%% END global tikz styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% global pgf styles

% Select only coordinates between a minimum and maximum data index
% `select coords between index={3}{9}` plots data for x-indices [3,4,5,6,7,8,9]
\pgfplotsset{%
  select coords between index/.style 2 args={%
    filter discard warning=false,%
    x filter/.code={%
      \ifnum\coordindex<#1\def\pgfmathresult{}\fi%
      \ifnum\coordindex>#2\def\pgfmathresult{}\fi%
    },%
  },%
  select only coord at index/.style={%
    filter discard warning=false,%
    x filter/.code={%
      \ifnum\coordindex=#1\else\def\pgfmathresult{}\fi%
    },%
  },%
}

% Order of draw layers
\pgfplotsset{%
  /pgfplots/layers/phlpptmpl/.define layer set={%
    axis background,%
    axis grid,%
    main,%
    axis ticks,%
    axis lines,%
    axis tick labels,%
    axis descriptions,%
    axis foreground,%
  }{%
    /pgfplots/layers/standard%
  },%
}%

% Do not complain about filtered coordinates
\pgfplotsset{%
  filter discard warning=false,%
}

% Make only some axes with fixed logarithmic tick poins
\pgfplotsset{%
  log x ticks with fixed point/.style={%
    xticklabel={%
      \pgfkeys{/pgf/fpu=true}%
      \pgfmathparse{exp(\tick)}%
      \pgfmathprintnumber[fixed relative, precision=3]{\pgfmathresult}%
      \pgfkeys{/pgf/fpu=false}%
    },%
  },%
  log y ticks with fixed point/.style={%
    yticklabel={%
      \pgfkeys{/pgf/fpu=true}%
      \pgfmathparse{exp(\tick)}%
      \pgfmathprintnumber[fixed relative, precision=3]{\pgfmathresult}%
      \pgfkeys{/pgf/fpu=false}%
    },%
  },%
}

%% END global tikz styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% mindmap style

\tikzphlpptmplset{%
  % Default mindmap node
  mindmap node/.style={%
    draw=PrimaryColor,%
    fill=White,%
    shape=rectangle,%
    rounded corners=0pt,%
    text centered,%
    transform shape,%
  },%
  %
  % Root node of a mindmap
  mindmap root/.style={%
    /phlpptmpl/mindmap node,%
  },%
  %
  % Leaf node of a mindmap
  mindmap leaf/.style={%
    /phlpptmpl/mindmap node,%
  },%
  %
  % Node that fits other nodes
  mindmap collection node/.style={%
    draw,%
    shape=rectangle,%
    rounded corners=0pt,%
    draw=PrimaryColor,%
    draw opacity=1.00,%
    fill=PrimaryColorVeryLight,%
    fill opacity=0.25,%
    text opacity=1.00,%
  },%
  %
  % Just a line between nodes
  mindmap line/.style={%
    -,%
    /phlpptmpl/thin,%
    shorten >=0.10ex,%
  },%
  %
  % Directed line between nodes
  mindmap direction/.style={%
    /phlpptmpl/mindmap line,%
    ->,%
  },%
  %
  % Thicker line connecting two nodes
  mindmap vector/.style={%
    /phlpptmpl/mindmap direction,%
    shorten >=0.10ex,%
    /phlpptmpl/thick,%
  },%
  %
  % Style for an annotation node along a line
  mindmap line annotation/.style={%
  },%
}

%% END mindmap style
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% cycle list styles

% Colors we will go through
\pgfplotscreateplotcyclelist{/phlpptmpl/color list}{%
  {%
    Black,%
    draw opacity=1.00,%
  },{%
    Black!66,%
    draw opacity=1.00,%
  },{%
    Black!33,%
    draw opacity=1.00,%
  }%
}

% Colors we will go through
\pgfplotscreateplotcyclelist{/phlpptmpl/black color}{%
  {%
    Black,%
    draw opacity=1.00,%
  }%
}

% Default list of line styles to go through
\pgfplotscreateplotcyclelist{/phlpptmpl/linestyles}{%
  {%
    solid,%
    draw opacity=1.00,%
  },{%
    dashed,%
    draw opacity=1.00,%
  },{%
    dashdotted,%
    draw opacity=1.00,%
  },{%
    dotted,%
    draw opacity=1.00,%
  }%
}

% Extended list of line styles to go through
\pgfplotscreateplotcyclelist{/phlpptmpl/linestyles*}{%
  {%
    dashed,%
    draw opacity=1.00,%
  },{%
    dashdotted,%
    draw opacity=1.00,%
  },{%
    dotted,%
    draw opacity=1.00,%
  },{%
    dashdotdotted,%
    draw opacity=1.00,%
  },{%
    densely dashed,%
    draw opacity=1.00,%
  },{%
    densely dashdotted,%
    draw opacity=1.00,%
  },{%
    densely dotted,%
    draw opacity=1.00,%
  },{%
    densely dashdotdotted,%
    draw opacity=1.00,%
  },{%
    loosely dashed,%
    draw opacity=1.00,%
  },{%
    loosely dashdotted,%
    draw opacity=1.00,%
  },{%
    loosely dotted,%
    draw opacity=1.00,%
  },{%
    loosely dashdotdotted,%
    draw opacity=1.00,%
  }%
}

%% END cycle list styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% mark list
% List of markers to go through
\pgfplotscreateplotcyclelist{/phlpptmpl/mark list}{%
  {%
    mark=*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=square*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=triangle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=star,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=none,%
      fill opacity=1.00,%
    },%
  },{%
    mark=diamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=otimes*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      % fill=\pgfplotsmarklistfill!33,%
      fill=PrimaryColor!33,%
      fill opacity=1.00,%
    },%
  },{%
    mark=|,%
    every mark/.append style={%
      solid,%
      rotate=180,%
      draw opacity=1.00,%
      fill=none,%
      fill opacity=1.00,%
    },%
  },{%
    mark=pentagon*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}

\pgfplotscreateplotcyclelist{/phlpptmpl/mark list*}{%
  {%
    mark=*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=square*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=triangle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=pentagon*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfcircle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfdiamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      rotate=180,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=otimes*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill!33,%
      fill opacity=1.00,%
    },%
  },{%
    mark=diamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare right*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare left*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}
%% END mark list
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% mark list nth
% List of markers to go through
\pgfplotscreateplotcyclelist{/phlpptmpl/mark list nth}{%
  {%
    mark=*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=square*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=triangle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=star,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=none,%
      fill opacity=1.00,%
    },%
  },{%
    mark=diamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=otimes*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill!33,%
      fill opacity=1.00,%
    },%
  },{%
    mark=|,%
    every mark/.append style={%
      solid,%
      rotate=180,%
      draw opacity=1.00,%
      fill=none,%
      fill opacity=1.00,%
    },%
  },{%
    mark=pentagon*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}

\pgfplotscreateplotcyclelist{/phlpptmpl/mark list nth*}{%
  {%
    mark=*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=square*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=triangle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=pentagon*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfcircle*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfdiamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      rotate=180,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=otimes*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill!33,%
      fill opacity=1.00,%
    },%
  },{%
    mark=diamond*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare right*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    mark=halfsquare left*,%
    every mark/.append style={%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}
%% END mark list
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% mark list even

% Different line styles and marking styles at the same time
\pgfplotscreateplotcyclelist{/phlpptmpl/mark list even}{%
  {%
    evenly marked plot={%
      *%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,,%
    },%
  },{%
    evenly marked plot={%
      square*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      triangle*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfsquare*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      pentagon*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfcircle*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfdiamond*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      otimes*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      diamond*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}%

% Different line styles and marking styles at the same time
\pgfplotscreateplotcyclelist{/phlpptmpl/mark list even*}{%
  {%
    evenly marked plot={%
      *%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      square*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      triangle*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfsquare*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      pentagon*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfcircle*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      halfdiamond*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      otimes*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=\pgfplotsmarklistfill!33,%
      fill opacity=1.00,%
    },%
  },{%
    evenly marked plot={%
      diamond*%
    }{%
      solid,%
      draw opacity=1.00,%
      fill=White,%
      % fill=\pgfplotsmarklistfill,%
      fill opacity=1.00,%
    },%
  }%
}%
%% END mark list even
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Different patterns for bar plots
\pgfplotscreateplotcyclelist{/phlpptmpl/black patterns}{%
  {%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill,%
    fill opacity=1.00,%
    pattern=north east lines,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill,%
    fill opacity=1.00,%
    pattern=north west lines,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill,%
    fill opacity=1.00,%
    pattern=crosshatch,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill,%
    fill opacity=1.00,%
    pattern=dots,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill,%
    fill opacity=1.00,%
    pattern=crosshatch dots,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill!25,%
    fill opacity=1.00,%
    pattern=north east lines,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill!25,%
    fill opacity=1.00,%
    pattern=north west lines,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill!25,%
    fill opacity=1.00,%
    pattern=crosshatch,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill!25,%
    fill opacity=1.00,%
    pattern=dots,%
  },{%
    draw=Black,%
    draw opacity=1.00,%
    fill=\pgfplotsmarklistfill!25,%
    fill opacity=1.00,%
    pattern=crosshatch dots,%
  }%
}%

% Add Style to cycle bars with a more natural cycle list name
\pgfplotsset{%
  bar cycle list/.style={%
    cycle list={%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill,%
        fill opacity=1.00,%
        pattern=north east lines,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill,%
        fill opacity=1.00,%
        pattern=north west lines,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill,%
        fill opacity=1.00,%
        pattern=crosshatch,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill,%
        fill opacity=1.00,%
        pattern=dots,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=White,%
        fill opacity=1.00,%
        pattern=crosshatch dots,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill!25,%
        fill opacity=1.00,%
        pattern=north east lines,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill!25,%
        fill opacity=1.00,%
        pattern=north west lines,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill!25,%
        fill opacity=1.00,%
        pattern=crosshatch,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill!25,%
        fill opacity=1.00,%
        pattern=dots,%
      },%
      {%
        draw=Black,%
        draw opacity=1.00,%
        fill=\pgfplotsmarklistfill!25,%
        fill opacity=1.00,%
        pattern=crosshatch dots,%
      }%
    }%
  }%
}%

%% END cycle list styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles

\providelength{\subplotwidth}
\providelength{\subplotheight}
\providelength{\subplothsep}
\providelength{\subplotvsep}

\pgfplotsset{%
  % General group settings
  group/horizontal sep=\subplothsep,%
  group/vertical sep=\subplotvsep,%
  %
  % Tufte styles
  tufte-like/.style={%
    axis line shift=10pt,%
    axis lines*=left,%
  },%
  plot base/.style={%
    % Scale only axis, not labels
    scale only axis=true,%
    %
    % Tufte like axis style
    axis line shift=5pt,%
    axis x line*=bottom,%
    axis y line*=left,%
    axis z line*=left,%
    tick align=outside,%
    %
    % Layers order
    set layers=phlpptmpl,%
    %
    % Skip coordinates that are outside of plot range
    unbounded coords=discard,%
    %
    % Default font size
    % font=\relsize{-1},%
    %
    % By default, do not add any marks to any of the plots
    % no markers,%
    %
    % I'd like to have no enlarged axes limits by defaults
    enlargelimits=false,%
    %
    % I'd like to have major grids on the y-axis
    ymajorgrids=true,%
    %
    % % And default legend styles
    every axis legend/.append style={%
      % draw=\tikzphlpptmplget{legend border color},%
      draw opacity=1.00,%
      fill=\tikzphlpptmplget{legend background color},%
      fill opacity=0.25,%
      text opacity=1.00,%
      % font=\relsize{-1},%
      at={(0.98,0.98)},%
      anchor=north east,%
      cells={%
        anchor=west,%
      },%
    },%
    %
    % Background of axis environment
    axis background/.append style={%
      fill=\tikzphlpptmplget{axis background color},%
    },%
    %
    % Style of axes lines
    every outer x axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    every outer y axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    every outer z axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    %
    % Draw axes above data
    axis on top=false,%
    %
    % Style of axes labels
    every axis x label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{xlabel color},%
    },%
    every axis y label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{ylabel color},%
    },%
    every axis z label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{zlabel color},%
    },%
    %
    % Style of tick labels
    every x tick label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{xlabel color},%
    },%
    every y tick label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{ylabel color},%
    },%
    every z tick label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{zlabel color},%
    },%
    %
    % Grid styles; axis, major and minor
    every axis grid/.style={%
      % shorten <=-10pt,%
    },%
    every major grid/.style={%
      dashed,%
      draw=\tikzphlpptmplget{major grid color},%
      % shorten <=-10pt,%
    },%
    every minor grid/.style={%
      loosely dashed,%
      draw=\tikzphlpptmplget{minor grid color},%
      % shorten <=-10pt,%
    },%
    %
    % Axes titles
    every axis title/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{title color},%
    },%
    %
    % Styles of `\addplot'
    every axis plot/.append style={%
      semithick,%
    },%
  },%
  %
  % Default line plot style
  line plot/.style={%
    % Inherit
    plot base,%
  },%
  %
  % A time series plot i.e., something-vs-time
  timeseries plot/.style={%
    % General adjustments
    line plot,%
    %
    % X-Axis
    xlabel={Time $t / \si{\second}$},%
  },%
  %
  % Y-bar plot
  ybar plot/.style={%
    % Base style to inherit from
    line plot,%
    % But make it bars
    ybar=#1,%
    %
    % Legend
    every axis legend/.append style={%
      at={(0.98,0.98)},%
      anchor=north east,%
    },%
  },%
  ybar plot/.initial=2pt,%
  %
  % Stacked y-bar plot
  ybar stacked plot/.style={%
    % General adjustments
    ybar plot=#1,%
    ybar stacked,%
  },%
  ybar stacked plot/.initial=2pt,%
  %
  % Boxplot
  boxplot plot/.style={%
    % Base style to inherit from
    line plot,%
    % But make it bars
    ybar=#1,%
    %
    % Legend
    every axis legend/.append style={%
      at={(0.98,0.98)},%
      anchor=north east,%
    },%
  },%
  boxplot plot/.initial=2pt,%
  %
  % Base style for double-y axes plots
  yyaxis line plot/.style={%
    % General styles
    line plot,%
    separate axis lines,%
  },%
  %
  % Double y-axis plot style: left axis
  yyaxis left/.style={%
    % General adjustments
    yyaxis line plot,%
    axis lines*=left,%
    %
    % X-Axis
    axis x line*=bottom,%
    %
    % Y-Axis
    axis y line*=left,%
    ylabel near ticks,%
    %
    % Style of axes labels
    every axis x label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{xlabel color},%
    },%
    every axis y label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{ylabel color},%
    },%
  },%
  %
  % Double y-axis plot style: right axis
  yyaxis right/.style={%
    % General adjustments
    yyaxis line plot,%
    axis lines*=right,%
    %
    % X-Axis
    axis x line=none,%
    %
    % Y-Axis
    axis y line*=right,%
    ylabel near ticks,%
    %
    % Axis
    axis background/.style={%
      fill=none,%
    },%
    %
    % Style of axes labels
    every axis x label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{xlabel color},%
    },%
    every axis y label/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{ylabel color},%
    },%
  },%
  %
  % Boxed axes style
  boxed axes/.style={%
    axis x line*=box,%
    axis y line*=box,%
  },%
  % Lower left axes style
  bottom left axes/.style={%
    axis x line*=bottom,%
    axis y line*=left,%
  },%
  % Top right axes styles
  top right axes/.style={%
    axis x line*=top,%
    axis y line*=right,%
  },%
}

% 3D plot styles
\pgfplotsset{%
  plot base 3d/.style={%
    % Scale only axis, not labels
    scale only axis=true,%
    %
    % Adjust view
    % view={20.00}{17.50},%
    view={15.00}{10.00},%
    %
    % Default font size
    % font=\relsize{-1},%
    %
    % I'd like to have no enlarged axes limits by defaults
    enlargelimits=false,%
    %
    % And default legend styles
    every axis legend/.append style={%
      draw=\tikzphlpptmplget{legend border color},%
      draw opacity=1.00,%
      fill=\tikzphlpptmplget{legend background color},%
      fill opacity=0.25,%
      text opacity=1.00,%
      % font=\relsize{-1},%
      at={(0.02,0.98)},%
      anchor=north west,%
      cells={%
        anchor=west,%
      },%
    },%
    %
    % Background of axis environment
    axis background/.append style={%
      fill=\tikzphlpptmplget{axis background color},%
    },%
    %
    % Style of axes lines
    every outer x axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    every outer y axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    every outer z axis line/.append style={%
      draw=\tikzphlpptmplget{axis border color},%
    },%
    %
    % Draw axes above data
    axis on top=false,%
    %
    % Style of axes labels
    every axis label/.append style={%
      % font=\relsize{-1},%
    },%
    every axis x label/.append style={%
      color=\tikzphlpptmplget{xlabel color},%
      sloped like x axis,%
    },%
    every axis y label/.append style={%
      color=\tikzphlpptmplget{ylabel color},%
      sloped like y axis,%
    },%
    every axis z label/.append style={%
      color=\tikzphlpptmplget{zlabel color},%
      sloped like z axis,%
    },%
    %
    % Style of tick labels
    every tick label/.append style={%
      color=\tikzphlpptmplget{xlabel color},%
    },%
    every x tick label/.append style={%
    },%
    every y tick label/.append style={%
    },%
    every z tick label/.append style={%
    },%
    %
    % Grid styles
    every major grid/.append style={%
      dashed,%
      draw=\tikzphlpptmplget{major grid color},%
    },%
    every minor grid/.append style={%
      loosely dashed,%
      draw=\tikzphlpptmplget{minor grid color},%
    },%
    %
    % Axes titles
    every axis title/.append style={%
      % font=\relsize{-1},%
      color=\tikzphlpptmplget{title color},%
    },%
  },%
  % Default 3D plot style
  line plot 3d/.style={%
    % Inherit
    plot base 3d,%
  },%
  %
  % Surface plot style
  surface plot/.style={%
    % Inherit
    line plot 3d,%
  },%
}

\tikzphlpptmplset{%
  zoom in spy box/.style={%
    solid,%
    draw=\tikzphlpptmplget{zoom in spy box color},%
    draw opacity=1.00,%
  },%
}

%% END plot styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for natural frequencies

\pgfplotsset{%
  % Style for natural frequencies plots
  natural frequencies base/.style={%
    % Inherit
    line plot,%
    %
    % General adjustments
    cycle list name=/phlpptmpl/mark list*,%
    unbounded coords=discard,%
    %
    % X-Axis
    enlarge x limits=0.05,%
    xmajorgrids=true,%
    %
    % Y-Axis
    ymajorgrids=true,%
    yminorgrids=true,%
    %
    % Legend
    every axis legend/.append style={%
      at={(0.98,0.02)},%
      % anchor=south east,%
      /tikz/every column/.append style={%
        anchor=west,%
      },%
      /tikz/every even column/.append style={%
        column sep=1.00ex,%
      },%
      /tikz/every odd column/.append style={%
        column sep=0.25ex,%
      },%
    },%
    legend columns=3,%
  },%
  % Style for natural frequencies plots
  natural frequencies/.style={%
    % Inherit
    natural frequencies base,%
    % 
    % General adjustments
    yyaxis left,%
    %
    % X-Axis
    xmin=1,%
    % extra x ticks={1},%
    xtick={1,2,4,...,100},%
    xlabel={Mode $k / \parentheses{}$},%
    %
    % Y-Axis
    ylabel={Frequency $\naturalfrequency_{k} / \si{\radian\per\second}$},%
  },%
  % Style for errors of natural frequencies
  natural frequencies error/.style={%
    % Inherit
    natural frequencies base,%
    %
    % General adjustments
    yyaxis right,%
    %
    % X-Axis
    xmin=1,%
    xtick={},%
    xticklabel={},%
    xlabel={},%
    %
    % Y-Axis
    ylabel={Error $\Delta \naturalfrequency_{k} / \si{\radian\per\second}$},%
  },%
  %
  % Style of the group plot for natural frequencies
  group/natural frequencies/.style={%
    % General stuff
    horizontal sep=\subplothsep,%
    vertical sep=\subplotvsep,%
    %
    % X-Axes
    xlabels at=edge bottom,%
    xticklabels at=edge bottom,%
    %
    % Y-Axes
    ylabels at=edge left,%
    yticklabels at=edge left,%
  },%
  % Style of the group plot for error in natural frequencies
  group/natural frequencies error/.style={%
    % General stuff
    horizontal sep=\subplothsep,%
    vertical sep=\subplotvsep,%s
    %
    % X-Axes
    xlabels at=edge bottom,%
    xticklabels at=edge bottom,%
    %
    % Y-Axes
    ylabels at=edge right,%
    yticklabels at=edge right,%
  },%
}

%% END plot styles for natural frequencies
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for catenary comparisons

\pgfplotsset{%
  %
  % Style for catenary comparison plots
  catenary planar/.style={%
    % Inherit
    line plot,%
    %
    % General adjustments
    cycle multiindex* list={%
      /phlpptmpl/linestyles*\nextlist%
      /phlpptmpl/mark list nth*%
    },%
    %
    % Legend style
    every axis legend/.append style={%
      at={(1.05, 1.00)},%
      anchor=north west,%
    },%
    % legend columns=2,%
    %
    % Axis
    axis equal,%
    title={Cartesian shape},%
    %
    % X-Axis
    enlarge x limits=0.02,%
    xlabel={Cartesian $x / \si{\meter}$},%
    xtick={-2.00,-1.80,-1.60,-1.40,-1.20,-1.00,-0.80,-0.60,-0.40,-0.20,0.00,0.20,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00},%
    minor x tick num=5,%
    xmajorgrids=true,%
    %
    % Y-Axis
    enlarge y limits=0.05,%
    ylabel={Cartesian $z / \si{\meter}$},%
    ytick={-2.00,-1.80,-1.60,-1.40,-1.20,-1.00,-0.80,-0.60,-0.40,-0.20,0.00,0.20,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00},%
    minor y tick num=5,%
    ymajorgrids=true,%
    %
    % Marker styles
    mark repeat=29,%
  },%
  catenary comparison/.style={%
    catenary planar,%
  },%
  %
  % Style for plot of residual vector norm
  catenary error residual vector norm/.style={%
    % Inherit
    line plot,%
    %
    % General adjustments
    cycle multiindex* list={%
      /phlpptmpl/linestyles*\nextlist%
      /phlpptmpl/mark list even*%
    },%
    %
    % Legend style
    every axis legend/.append style={%
      at={(1.05, 1.00)},%
      anchor=north west,%
    },%
    % legend columns=2,%
    %
    % Axis
    title={Residual vector norm},%
    %
    % X-Axis
    xmin=0.00,%
    xmax=1.00,%
    enlarge x limits=0.02,%
    xlabel={Path coordinate $\pathcoord / \parentheses{}$},%
    % xlabel={Cartesian $x / \si{\meter}$},%
    % xtick={-2.00,-1.80,-1.60,-1.40,-1.20,-1.00,-0.80,-0.60,-0.40,-0.20,0.00,0.20,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00},%
    % minor x tick num=5,%
    xmajorgrids=true,%
    %
    % Y-Axis
    ymin=1e-6,%
    ymax=1.00,%
    % ymode=log,%
    ytickten={-12,-9,-6,-3,0,3},%
    enlarge y limits=0.02,%{upper,value=0.02},%
    ylabel={Residual vector norm $\residual_{\curve} / \parentheses{}$},%
    % ylabel={Residual $\norm{\curve_{\ms{irvine}} - \curve_{\ms{b-spline}}}$},%
    % ytick={-2.00,-1.80,-1.60,-1.40,-1.20,-1.00,-0.80,-0.60,-0.40,-0.20,0.00,0.20,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00},%
    % minor y tick num=5,%
    ymajorgrids=true,%
    axis y line*=right,%
    %
    % Marker styles
    mark repeat=29,%
  },%
  % Style for plot of residual vector norm
  catenary error residual area norm/.style={%
    % Inherit
    line plot,%
    %
    % General adjustments
    cycle multiindex* list={%
      /phlpptmpl/linestyles*\nextlist%
      /phlpptmpl/mark list even*%
    },%
    %
    % Legend style
    every axis legend/.append style={%
      at={(1.05, 1.00)},%
      anchor=north west,%
    },%
    % legend columns=2,%
    %
    % X-Axis
    xmin=1.00,%
    xtick={1,5,10,15,20},%
    enlarge x limits=0.02,%
    xlabel={\# Segments $\numsegments / \parentheses{}$},%
    xmajorgrids=true,%
    %
    % Y-Axis
    ymin=0.00,%
    enlarge y limits={upper,value=0.05},%
    ymajorgrids=true,%
    every y tick label/.append style={%
      /pgf/number format/fixed,%
    },%
    ylabel={Residual $\residual*_{\curve} / \parentheses{}$},%
    scaled y ticks=base 10:2,%
    %
    % Marker styles
    /tikz/mark repeat=29,%
  },%
  % Style of the group plot for catenary comparison
  group/catenary comparison/.style={%
    % General stuff
    horizontal sep=\subplothsep,%
    vertical sep=\subplotvsep,%
    %
    % X-Axes
    xlabels at=edge bottom,%
    xticklabels at=edge bottom,%
    %
    % Y-Axes
    ylabels at=all,%
    yticklabels at=all,%
  },%
}

%% END plot styles for catenary comparisons
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for iteration residual

\pgfplotsset{%
  static residual iteration/.style={%
    % Inherit
    line plot,%
    %
    % General adjustments
    cycle multiindex* list={%
      /phlpptmpl/black color\nextlist%
      /phlpptmpl/linestyles\nextlist%
      /phlpptmpl/mark list*%
    },%
    log x ticks with fixed point,%
    %
    % Legend style
    every axis legend/.append style={%
      at={(0.98, 0.98)},%
      anchor=north east,%
    },%
    %
    % X-Axis
    xmin=1,%
    xmax=500,%
    xlabel={Iteration step $\iterindex / \parentheses{}$},%
    xtickten={0,1,2,3},%
    xmajorgrids=true,%
    xminorgrids=true,%
    %
    % Y-Axis
    ymin=1e-12,%
    ymax=1e3,%
    ylabel={Residual norm $\norm{ \residual_{\iterindex} } / \parentheses{}$},%
    ytickten={-12,-9,-6,-3,0,3,6},%
    ymajorgrids=true,%
  },%
}

%% END plot styles for iteration residual
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for cable robots

\pgfplotsset{%
  %
  % Cable robot plot 2D
  cable robot/.style={%
    % Inherit
    line plot,%
    blend mode=overlay,%
    %
    % General adjustments
    unit vector ratio*=1 1 1,%
    %
    % X-Axis
    xmin=-1,%
    xmax=1,%
    enlarge x limits=0.05,%
    xlabel={Horizontal $x / \si{\meter}$},%
    xtick={-1.00,-0.50,...,1.00},%
    minor x tick num=5,%
    xmajorgrids=true,%
    %
    % Y-Axis
    ymin=-1,%
    ymax=1,%
    enlarge y limits=0.05,%
    ylabel={Vertical $z / \si{\meter}$},%
    ytick={-1.00,-0.50,...,1.00},%
    minor y tick num=5,%
    ymajorgrids=true,%
  },%
  %
  % Cable robot plot 3D
  cable robot 3d/.style={%
    % Inherit
    line plot 3d,%
    % z buffer=sort,%
    %
    % General adjustments
    unit vector ratio*=1 1 1,%
    %
    % X-Axis
    xmin=-1,%
    xmax=1,%
    enlarge x limits=0.05,%
    xlabel={Horizontal $x / \si{\meter}$},%
    % xtick={-1.00,-0.50,...,1.00},%
    minor x tick num=4,%
    xmajorgrids=true,%
    %
    % Y-Axis
    ymin=-1,%
    ymax=1,%
    enlarge y limits=0.05,%
    ylabel={Horizontal $y / \si{\meter}$},%
    % ytick={-1.00,-0.50,...,1.00},%
    minor y tick num=4,%
    ymajorgrids=true,%
    %
    % Z-Axis
    zmin=-1,%
    zmax=1,%
    enlarge z limits=0.05,%
    zlabel={Vertical $z / \si{\meter}$},%
    % ztick={-1.00,-0.50,...,1.00},%
    minor z tick num=4,%
    zmajorgrids=true,%
  },%
}

%% END plot styles for cable robots
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for cable robot components

\tikzphlpptmplset{%
  % Cable robot style
  cable robot/.style={%
    blend mode=overlay,%
  },%
  %
  % Cable drawing style
  cable robot cable/.style={%
    draw=Red,%
    % /phlpptmpl/semithick,%
    solid,%
    line cap=rect,%
    forget plot,%
    unbounded coords=discard,%
  },%
  %
  % Platform drawing style
  cable robot platform/.style={%
    patch,%
    draw=PrimaryColorDark,%
    fill=PrimaryColorLight,%
    draw opacity=1.00,%
    fill opacity=0.75,%
    solid,%
    % z buffer=sort,%
    shader=flat,%
    faceted color=PrimaryColorLight,%
    forget plot,%
    % unbounded coords=discard,%
  },%
  %
  % Frame anchor drawing style
  cable robot frame anchor/.style={%
    draw=PrimaryColor,%
    only marks,%
    mark=triangle*,%
    mark options={%
      solid,%
      draw=PrimaryColor,%
      fill=PrimaryColorLight,%
    },%
    mark size=1.50pt,%
    forget plot,%
    unbounded coords=discard,%
  },%
  %
  % Platform anchor drawing style
  cable robot platform anchor/.style={%
    only marks,%
    mark=*,%
    mark options={%
      solid,%
      draw=PrimaryColor,%
      fill=PrimaryColorLight,%
    },%
    mark size=1.50pt,%
    forget plot,%
    unbounded coords=discard,%
  },%
  cable robot platform anchor background/.style={%
    /phlpptmpl/cable robot platform anchor,%
    shader=flat,%
    draw opacity=0.75,%
    fill opacity=0.75,%
  },%
  %
  % Caro ground
  cable robot ground/.style={%
    patch,%
    patch type=rectangle,%
    draw=Gray,%
    fill=Gray,%
    draw opacity=1.00,%
    fill opacity=0.50,%
    solid,%
    shader=flat,%
    faceted color=White,%
    forget plot,%
    unbounded coords=discard,%
    table/row sep=\\,%
  },%
}

%% END plot styles for cable robot components
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plot styles for material step responses

\pgfplotsset{%
  material step/.style={%
    % General adjustments
    cycle multiindex* list={%
      /phlpptmpl/linestyles*\nextlist%
      /phlpptmpl/mark list even*%
    },%
    % 
    % X-Axis
    xmin=0.00,%
    xmax=2.00,%
    xlabel={Dimensionless time},%
    enlarge x limits=0.05,%
    restrict x to domain=0:2.0001,%
    filter discard warning=false,%
    %
    % Y-Axis
    ylabel={Amplitude},%
  },%
  %
  material step strain2stress/.style={%
    % Inherit
    yyaxis left,%
    material step,%
    %
    % General adjustment
    %
    % Legend
    every axis legend/.append style={%
      at={(0.98,0.98)},%
      anchor=north east,%
    },%
    %
    % Y-Axis
    ymin=0.00,%
    ymax=5.00,%
    ylabel={Stress},%
  },%
  %
  material step stress2strain/.style={%
    % Inherit
    yyaxis right,%
    material step,%
    %
    % General adjustment
    %
    % Legend
    every axis legend/.append style={%
      at={(0.98,0.98)},%
      anchor=north east,%
    },%
    %
    % Y-Axis
    ymin=0.00,%
    ymax=1.00,%
    ylabel={Strain},%
  },%
}

%% END plot styles for material step responses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
